
public final class Node extends Point {

   public int g;
   public Integer f;
   public Node prev;
   
   public Node(int x, int y, Node prev, Point goal) {
      super(x, y);
      this.prev = prev;
      g = prev == null ? 0 : prev.g + 1;
      f = new Integer(g + distance(goal));
   }
   
   public Node(Point p, Node prev, Point goal) {
      this(p.x, p.y, prev, goal);
   }

}