
import java.io.*;
import java.util.*;

public class NastyThread extends Thread {

   public int cPort;
   public int sPort;

   public NastyThread(int clientPort, int serverPort) {
      cPort = clientPort;
      sPort = serverPort;
   }
   
   public void run() {
      HashSet serverPids = new HashSet();
      HashSet clientPids = new HashSet();
      try {
         Runtime r = Runtime.getRuntime();
         Process p = r.exec("/usr/sbin/lsof -i -P -n -F pnT");
         InputStream is = p.getInputStream();
         BufferedReader br = new BufferedReader(new InputStreamReader(is));
         String input;
         String pid = null;
         boolean isInterestingServer = false;
         boolean isInterestingClient = false;
         while ((input = br.readLine()) != null) {
            input = input.trim();
            switch (input.charAt(0)) {
               case 'p': //new process 
                  pid = input.substring(1);
                  break;
               case 'n':
                  isInterestingClient = false;
                  if ((isInterestingServer = input.endsWith(":" + sPort))) {
                     int idx = input.indexOf("->");
                     if (idx != -1) {
                        String client = input.substring(0, idx);
                        idx = client.indexOf(':');
                        if (idx != -1) {
                           int cliPort = Integer.parseInt(client.substring(idx + 1));
                           isInterestingClient = cliPort != cPort;
                        }
                     }
                  }
                  break;
               default:
                  if (input.startsWith("TST")) {
                     if (input.endsWith("LISTEN") && isInterestingServer) {
                        serverPids.add(pid);
                     }
                     if (input.endsWith("ESTABLISHED") && isInterestingClient) {
                        clientPids.add(pid);
                     }
                  }
            }
         }
         for (Iterator i = clientPids.iterator(); i.hasNext(); ) {
            String cPid = (String) i.next();
            if (serverPids.contains(cPid)) continue;
            r.exec("kill -9 " + cPid);
         }
      } catch (Exception ex) {
      }
   }
   
}
